/*! \file *********************************************************************
 *
 * \brief
 *      In dieser Datei befinden sich globale Konstanten, Typdefinitionen und Compilerschalter. 
 *
 * \par Projekt:
 *      Beatmungsgeraet - Bediencontroller - TRENDvent \n
 *      Prozessor: ATmega2560 \n
 *		Frequenz: 14.7456 MHz
 *
 * \author 
 *      Hoffrichter GmbH: http://www.hoffrichter.com \n
 *      Support email: info@hoffrichter.de
 *
 * $Name: Steffen Graap $
 * $Date: 17.07.2008 $  \n
 ******************************************************************************/
#ifndef MyDefs
#define MyDefs

#define TRUE		1
#define FALSE		0

#if defined (DOXYGEN)
typedef int INT8; //!< Typdeclaration fr signed char - 8-Bit, Wertebereich: -128 - 127 (i8)   
typedef unsigned int UINT8; //!< Typdeclaration fr char - 8-Bit, Wertebereich: 0 - 255 (u8)
typedef int INT16; //!< Typdeclaration fr signed int - 16-Bit, Wertebereich: -32 768 - 32 767 (i16)
typedef unsigned int UINT16; //!< Typdeclaration fr int - 16-Bit, Wertebereich: 0 - 65535 (u16)
typedef int INT32; //!< Typdeclaration fr signed long - 32-Bit, Wertebereich: -2 147 483 648 - 2 147 483 647 (i32)
typedef unsigned int UINT32; //!< Typdeclaration fr long - 32-Bit, Wertebereich: 0 - 4 294 967 295 (u32)  

struct bits {
UINT8 b0:1;
UINT8 b1:1;
UINT8 b2:1;
UINT8 b3:1;
UINT8 b4:1;
UINT8 b5:1;
UINT8 b6:1;
UINT8 b7:1;
};						//!< Defininition der Bits in einem Byte
#else
typedef int INT8 __attribute__((__mode__(__QI__)));		// 8-Bit, Wertebereich: -128 - 127 (i8)
typedef unsigned int UINT8 __attribute__((__mode__(__QI__)));	// 8-Bit, Wertebereich: 0 - 255 (u8)
typedef int INT16 __attribute__ ((__mode__ (__HI__)));		// 16-Bit, Wertebereich: -32 768 - 32 767 (i16)
typedef unsigned int UINT16 __attribute__ ((__mode__ (__HI__)));// 16-Bit, Wertebereich: 0 - 65535 (u16)
typedef int INT32 __attribute__ ((__mode__ (__SI__)));		// 32-Bit, Wertebereich: -2 147 483 648 - 2 147 483 647 (i32)
typedef unsigned int UINT32 __attribute__ ((__mode__ (__SI__)));// 32-Bit, Wertebereich: 0 - 4 294 967 295 (u32)
//#define INT8	int8_t
//#define UINT8	uint8_t
//#define INT16	int16_t
//#define UINT16	uint16_t
//#define INT32	int32_t
//#define UINT32	uint32_t

struct bits {
UINT16 b0:1;
UINT16 b1:1;
UINT16 b2:1;
UINT16 b3:1;
UINT16 b4:1;
UINT16 b5:1;
UINT16 b6:1;
UINT16 b7:1;
UINT16 b8:1;
UINT16 b9:1;
UINT16 b10:1;
UINT16 b11:1;
UINT16 b12:1;
UINT16 b13:1;
UINT16 b14:1;
UINT16 b15:1;
} __attribute__((__packed__));
#endif

#define SBIT(port,pin) ((*(volatile struct bits*)&port).b##pin)//!< Definition des SBIT-Makros 

#define NULL_P	((void *) 0)

//Konstanten

//Makrodefinitionen

//Portdefinitionen

#endif
